# simulation under the alternative hypothesis, with number of Risk/Protective/Neutral variants: 45%/45%/10%, genetic effect sampled from unif[0.05, 0.2]
# for mixed individuals, mixed variants, n = 1600, nsnp = 100, rho = 0.2, 0.5, 0.8, nsimu = 100
library(mvtnorm)

sourcepath <- "C:/Work/ABTpackage/Source"
resultpath <- "C:/Work/ABTpackage/Result"
temppath <- "C:/Work/ABTpackage/Temp"
source(paste(sourcepath, "generatepedstrmix.R", sep = "/"))
source(paste(sourcepath, "generatelatcorrmat.R", sep = "/"))
source(paste(sourcepath, "generateZY_Ha.R", sep = "/"))
source(paste(sourcepath, "generatefdrG.R", sep = "/"))
source(paste(sourcepath, "generatepedG.R", sep = "/"))
source(paste(sourcepath, "generateG.R", sep = "/"))
source(paste(sourcepath, "estimateVC.R", sep = "/"))
source(paste(sourcepath, "calculateV.R", sep = "/"))
source(paste(sourcepath, "calculateLambda_Wmat.R", sep = "/"))
source(paste(sourcepath, "ABT.R", sep = "/"))

sd <- 0
nsimu <- 100
nfam <- 80
pedstrmix <- generatepedstrmix()
nind.pf <- nrow(pedstrmix)
b <- c(1, 0.6)
s2 <- c(2, 2)
lb.a <- 0.05
ub.a <- 0.2

load(paste(temppath, "PHImix.pf.RData", sep = "/"))

for (nsnp in c(100))
{
  for (eta in c(0.2, 0.5, 0.8))
  {
    S.ABT <- rep(NA, nsimu)
    Lambda.mat <- matrix(NA, nsimu, nsnp)
    
    set.seed(sd)
    latcorrmatforfdr <- generatelatcorrmat(nsnp, eta)
    # for R/P/N: 45%/45%/10%
    g <- c(runif(round(0.45 * nsnp), lb.a, ub.a), runif(round(0.45 * nsnp), -ub.a, -lb.a), rep(0, nsnp - round(0.45 * nsnp) - round(0.45 * nsnp)))
    runt <- system.time({
      for(i in 1 : nsimu)
      {
        # generate genotype/phenotype data
        alfreqforfdr.tmp <- c(runif(round(0.5 * nsnp), 0.1, 0.5), runif(nsnp - round(0.5 * nsnp), 0.01, 0.1))
        alfreqforfdr <- sample(alfreqforfdr.tmp, nsnp)
        G <- generateG(nfam, pedstrmix, alfreqforfdr, latcorrmatforfdr)
        ZY <- generateZY_Ha(nfam, pedstrmix, b, s2, PHImix.pf, G, g)
        Y <- ZY$Y
        Z <- ZY$Z # Z includes intercept
        # calculate ABT statistic and lambda's
        ABT.result <- ABT(Y, Z, G, PHImix.pf)
        Lambda.mat[i, ] <- ABT.result$Lambda
        S.ABT[i] <- ABT.result$tstat
        
      }
    })
    save(nsimu, runt, S.ABT, Lambda.mat, file = paste(resultpath, "/Ha_IXa_sd_", sd, "_nsnp_", nsnp, "_eta_", eta, ".RData", sep = ""))
  }
}
